#include "monitoring.h"

#include <stdio.h>

// some global timers
Timer total_timer, godunov_timer, dt_timer, boundaries_timer, io_timer;

// =======================================================
// =======================================================
void timerReset(Timer* timerPtr)
{

  timerPtr->start_time.tv_sec = 0;
  timerPtr->start_time.tv_usec = 0;
  timerPtr->total_time = 0.0;

} // timerReset

// =======================================================
// =======================================================
void timerStart(Timer* timerPtr)
{
  
  if (-1 == gettimeofday(&(timerPtr->start_time), 0))
    fprintf(stderr,"Timer: Couldn't initialize start_time time");

} // timerStart

// =======================================================
// =======================================================
void timerStop(Timer* timerPtr)
{

  double accum;

  // get current time
  timeval_t now;
  if (-1 == gettimeofday(&now, 0))
    fprintf(stderr,"Couldn't get current time");

  // accumulate time between last start and now
  if (now.tv_sec == timerPtr->start_time.tv_sec)
    accum = (double) (now.tv_usec - timerPtr->start_time.tv_usec) * 1e-6;
  else
    accum = (double) (now.tv_sec - timerPtr->start_time.tv_sec) +
      ( (double) (now.tv_usec - timerPtr->start_time.tv_usec) * 1e-6);

  timerPtr->total_time += accum;

} // timerStop

// =======================================================
// =======================================================
double timerElapsed(Timer* timerPtr)
{

  return timerPtr->total_time;

} // timerElapsed
